// C Source File
// Created 06/08/02; 18:59:49

// Nibbles avec les touches left & right

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents 

#define ARROWS_ROW 0xfffe
#define LEFT_KEY 2
#define RIGHT_KEY 8
#define UP_KEY 1
#define DOWN_KEY 4
#define SECOND_KEY 16
#define ESC_ROW 0xffbf
#define ESC_KEY 1
#define DIAMOND_KEY 64
#define SHIFT_KEY   32
#define ALPHA_KEY   128

#define ADDBONUS 22

#include <tigcclib.h>         // Include All Header Files


short _ti89;                  // Produce .89Z File

void desscare(unsigned char, unsigned char, short);
int playgame(void);
void newbonus(void);
void contour(void);
void clearbonus(void);
void input_str(int,int);
void printhsc(void);
void stcpy(char *cible, char *source);
int playagain(void);


unsigned char bonus[2], critic;
static int topsco[5];
static char best[5][20];
static char tmp[20];

 void FillColorRect(int x1,int y1,int x2, int y2,short style)
 {
    SCR_RECT rect;
    SCR_RECT fullscreen={{0,0,159,99}};
    rect.xy.x0 = x1;
    rect.xy.y0 = y1;
    rect.xy.x1 = x2;
    rect.xy.y1 = y2;
    ScrRectFill(&rect,&fullscreen, style);
 }


void _main(void)
{
FILE *scorep; /*C file pointer*/
SYM_ENTRY *filep; /*VAT file pointer*/
int s;

filep = SymFindPtr($(rnibsco), 0); /*see if the high score file exists*/
if(filep != NULL) /*if it does*/
	if(filep->flags.bits.archived) /*and it is archived*/
		EM_moveSymFromExtMem($(rnibsco), HS_NULL); /*unarchive it*/
scorep = fopen("rnibsco", "rb"); /*try to open the file that the scores are saved in*/
if(scorep == NULL) /*if the file does not exist*/
{
	for(s=0;s<5;s++)
	{	strcpy(&best[s][0], "cedric");
		topsco[s]=5-s;
	}
	topsco[0]=37;
}
else /*if the file does exist*/ 
{
	/*get the high scores from the file*/
	rewind(scorep);
	for(s=0;s<5;s++)
	{	fread(&topsco[s],2,1,scorep);
   	fread(&best[s][0],1,20,scorep);
   }
}
	fclose(scorep);
//fin gestion files

	clrscr();
	//intro
	FontSetSys(F_4x6);
	printf_xy(0,0,"RADIAL NIBBLES by Cedric Martel");
	printf_xy(0,72,"left & right to move, 2nd to pause");
	printf_xy(0,81,"if you beat high score mail cedma@caramail.com");
	printf_xy(30,90,"press any key to continue...");
	printhsc();
	ngetchx();
rejouer:
	clrscr();
	contour();
	s=playgame();
	clrscr();
	printf_xy(0, 0, "GAME OVER");
	printhsc();
	printf_xy(0, 60, "you've made %d", s);
	if(playagain()==1)	goto rejouer;
	if(critic==1)
	{
		clrscr();
		printf_xy(0,0,"I need at least 5KO to run!");
		ngetchx();
	}
	scorep = fopen("rnibsco", "w+b");
	// rewind(scorep);
	for(s=0;s<5;s++)
	{	fwrite(&topsco[s],2,1,scorep);
   	fwrite(&best[s][0],1,20,scorep);
   }
	putc(0,scorep);
	fputs("HSC", scorep);
	putc(0, scorep);
	putc(OTH_TAG, scorep);
	fclose(scorep);
	EM_moveSymToExtMem($(rnibsco), HS_NULL); /*archive the file*/
}


int playgame(void)
{
	unsigned char *x, *y, cx, cy, r;
	char tmp1;
	register unsigned char s,t,oldx, oldy;
	int hit, curent;
	register float angle;
	int maxind, index, c;
	int sco;
	
	critic=0;
	x=malloc(1400);
	y=malloc(1400);
	if(x==NULL || y==NULL)
		{		critic=1;	return 0;		}
	index=ADDBONUS;
	maxind=ADDBONUS;
	x[0]=30;
	y[0]=55;
	cx=30;	//centre du cercle trigo
	cy=55;	//
	r=1;  	//rayon
	curent=0;
	angle=0.001;	//en radian!!
	hit=0;
	sco=0;
 	printf_xy(70,0,"top : %d par %0.20s", topsco[0], &best[0][0]);
	printf_xy(0,0,"score : 0");
	newbonus();
	
	while(!(hit || _rowread(ESC_ROW)&ESC_KEY))
	 {
		c=_rowread(ARROWS_ROW);
		if(c&SECOND_KEY) off();
		if((c&RIGHT_KEY) || (c&LEFT_KEY))
			{
				cx=x[curent];
				cy=y[curent];
				r=1;
				tmp1=0;
				if(c&RIGHT_KEY)
					tmp1=1;
				if(c&LEFT_KEY)
					tmp1-=1;
				angle=angle-tmp1*0.2;
				if(angle<0)		angle+=6.3;		//un peu major
				if(angle>6.3)	angle-=6.3;
			}
		r++;
	 	oldx=x[curent];
	 	oldy=y[curent];
	 	if(curent==maxind)
	 		curent=0;
	 	else
	 		curent++;
	 		
	 	if(index>0 && curent+index-1==maxind)
	 	 	index--;
	 	else  //on efface l'ancien carr
	 	 	desscare(x[curent], y[curent], A_REVERSE);
	 	 
	 	//le nouveau carr	 	
		if(oldx>2 && oldx<159)
		 	x[curent]=cx+(int)(r*cos(angle));
		else
			hit=1;
	 	if(oldy>10 && oldy<99)
	 		y[curent]=cy-(int)(r*sin(angle));
		else
			hit=1;

	 	//test collision
	 	if(x[curent]>=bonus[0]-1 && x[curent]<=bonus[0]+2 && y[curent]>=bonus[1]-1 && y[curent]<=bonus[1]+2)
	 	{//si bonus
	 		maxind+=ADDBONUS;
	 		index+=ADDBONUS;
	 		if(maxind>1399)	{ index-=maxind-1399; maxind=1399; }
	 		sco++;
	 		clearbonus();
	 		newbonus();
		 	printf_xy(0,0,"score : %d  ", sco);
	 		goto after;
	 	}
	 	for(s=x[curent];s<x[curent]+2;s++)
	 	{
	 	 	for(t=y[curent];t<y[curent]+2;t++)
	 	 	{	
	 	 		if(GetPix(s,t))
	 	 		{
		 	 		if((oldx!=s && oldx+1!=s) || (oldy!=t && oldy+1!=t))
		 	 				hit=1;
	 	 		}
	 	 	}
	 	}
after:
		desscare(x[curent], y[curent], A_NORMAL);
	 	
	 };	//end of while
	
	free(x);
	free(y);
	if(sco>topsco[4])	
	{	
	   ST_modKey(ST_SH_A_LOCK);
	   FillColorRect(38,53,105,83,A_NORMAL);
		DrawStr(40, 55, "NEW RECCORD", A_REVERSE);
		DrawStr(40, 65, "enter your name : ", A_REVERSE);
		input_str(40, 75);
		
		// classer les scores avant de les enregistrer
	 	for(index=0;index<5;index++)
	 	{
	 	  if(sco>topsco[index])
	 		{
	 		   if(index!=4)
	 		   {
	 		   for(c=4;c>index;c--)
	 			{
	 				topsco[c]=topsco[c-1];
	 				stcpy(best[c],best[c-1]);
	 			}
	 			}
	 		   topsco[index]=sco;
	 			stcpy(best[index], tmp);
	 			break;
//	 			goto finsub;
	 		}
	 	}
//finsub:
	}
	else
		ngetchx();
return sco;
}

void stcpy(char *cible, char *source)
{
	int t;
	for(t=0;t<20;t++)			cible[t]=source[t];
}

void newbonus(void)
{
	register char t1, t2;
again:
	bonus[0]=rand()%155+2;	//x
	bonus[1]=rand()%86+11;		//y
	for(t1=0;t1<3;t1++)
	{
	 	for(t2=0;t2<3;t2++)
	 		{
	 		if(GetPix(bonus[0]+t1,bonus[1]+t2))
	 			goto again;
	 		}	  
	}
	DrawLine(bonus[0],bonus[1],bonus[0],bonus[1]+2, A_NORMAL);
	DrawLine(bonus[0]+2,bonus[1],bonus[0]+2,bonus[1]+2, A_NORMAL);
	DrawLine(bonus[0],bonus[1],bonus[0]+2,bonus[1], A_NORMAL);
	DrawLine(bonus[0],bonus[1]+2,bonus[0]+2,bonus[1]+2, A_NORMAL);
}

void clearbonus(void)
{
	register char t1;
	for(t1=0;t1<3;t1++)
		DrawLine(bonus[0]+t1, bonus[1],bonus[0]+t1, bonus[1]+2, A_REVERSE);		  
}

void desscare(unsigned char abs,unsigned char ord, short sty)
{
	DrawLine(abs, ord, abs+1, ord,sty); 
	DrawLine(abs, ord+1, abs+1, ord+1,sty); 
}

void contour(void)
{
	DrawLine(0, 8, 0, 99, A_NORMAL);
	DrawLine(1, 8, 1, 99, A_NORMAL);
	DrawLine(0, 8, 159, 8, A_NORMAL);
	DrawLine(0, 9, 159, 9, A_NORMAL);
	DrawLine(159, 8, 159, 99, A_NORMAL);
	DrawLine(158, 8, 158, 99, A_NORMAL);
	DrawLine(0, 99, 159, 99, A_NORMAL);
	DrawLine(0, 98, 159, 98, A_NORMAL);
}

void input_str(int x,int y)
{
  int i=0,key;
  key=0;
  ////////here
  while(key!=13)
    {
      tmp[i]='_'; tmp[i+1]=' '; tmp[i+2]=' '; tmp[i+2]=0;
      DrawStr(x,y,tmp,A_REVERSE);
      key=ngetchx();
      if(key>=' '&&key<='~'&&i<19) tmp[i++]=key;
      if(key==257&&i) i--;
    }
  for(key=i;key<25;key++)
    tmp[key]=' ';
}

void printhsc(void)
{
	int u;
	printf_xy(10,10,"high scores :");
	for(u=0;u<5;u++)
		printf_xy(10,18+u*8, "%d par %0.20s", topsco[u], &best[u][0]);
}

int playagain(void)
{
	int f=0,c=338;
	DrawStr(80,0,"REJOUER?",A_NORMAL);
	while(c==338||c==344)
	{
		if(f)	{	DrawStr(84,10,"<-NON->", A_REPLACE);  f=0; }
		else 	{  DrawStr(84,10,"<-OUI->  ", A_REPLACE);  f=1; }
		c=ngetchx();
		if(c==264) { f=0; break; }
	}
	return f;
}
